# 查询计费用量汇总

```{raw} html
<div class="mo-api-page-show-toc" aria-hidden="true"></div>
```

按账期、小时、天或月汇总计费用量，并按计量项、工作区和记录状态分组。

```text
GET https://billing.moi.matrixorigin.cn/api/v1/billing/accounts/$ACCOUNT_ID/usage-summary
```

## 调用前准备

1. 准备计费账户所属用户的有效[个人访问令牌](../../../../../guides/genesis/api-keys.md#创建和管理个人访问令牌)。
2. 调用[查询当前账户](../accounts/current.md)接口，获取目标账户的 ID。

## 请求示例

将示例中的 `$MOI_PERSONAL_ACCESS_TOKEN` 和 `$ACCOUNT_ID` 分别替换为个人访问令牌和所选账户的 ID。

```bash
curl -X GET \
  "https://billing.moi.matrixorigin.cn/api/v1/billing/accounts/$ACCOUNT_ID/usage-summary?granularity=period" \
  -H "X-API-Key: $MOI_PERSONAL_ACCESS_TOKEN"
```

## 路径参数

::::{div} mo-api-parameter-table

| 参数 | 类型 | 是否必填 | 说明 |
| --- | --- | --- | --- |
| `accountID` | string | 是 | 目标账户的 ID，取自“查询当前账户”响应中的 `items[].billing_account_id`。 |

::::

## 查询参数

::::{div} mo-api-parameter-table

| 参数 | 类型 | 是否必填 | 说明 |
| --- | --- | --- | --- |
| `from` | string | 否 | 按记录创建时间筛选的起点，包含该时刻；支持 RFC 3339、`YYYY-MM-DD` 或 Unix 秒字符串。省略时从包含当天在内的最近 30 天起点开始。 |
| `to` | string | 否 | 按记录创建时间筛选的终点，不包含该时刻。日期值扩展到所选日期的次日零点。省略时使用计费时区的明日零点。 |
| `timezone` | string | 否 | IANA 时区；省略时使用账户地区的计费时区。 |
| `granularity` | string | 否 | 时间粒度：period、hour、day、month，默认 period。 |
| `period_granularity` | string | 否 | granularity 的兼容参数；仅在 granularity 为空时使用。 |
| `period` | string | 否 | 按入账账期筛选，格式为 `YYYY-MM`。 |
| `meter_code` | string | 否 | 按计量项代码筛选。 |
| `billing_item_code` | string | 否 | 按计费项代码筛选；与 `meter_code` 同时提供时须匹配同一计量项。 |
| `workspace_id` | string | 否 | 按用量事件所属工作区筛选。 |
| `status` | string | 否 | 按用量记录状态筛选；查询已扣费记录时使用 charged。省略时不按状态筛选。 |
| `subject_type` | string | 否 | 按账户归属主体类型筛选。 |
| `subject_id` | string | 否 | 按账户归属主体 ID 筛选。 |
| `q` | string | 否 | 搜索计费用量记录 ID、用量事件 ID、计量项代码或事件键，不区分大小写。 |
| `search` | string | 否 | q 的兼容参数，仅在 q 为空时使用。 |

::::

## 成功响应

请求成功时返回 HTTP `200` 和按所选时间粒度汇总的用量和费用。

:::::::{div} mo-api-tabs mo-api-response-tabs
::::::{tab-set}
:::::{tab-item} 响应示例

```json
{
  "items": [
    {
      "bucket_start": "2026-09-01T00:00:00+08:00",
      "bucket_end": "2026-10-01T00:00:00+08:00",
      "bucket_start_unix": 1788192000,
      "bucket_end_unix": 1790784000,
      "period": "2026-09",
      "meter_code": "meter_example",
      "billing_item_code": "meter_example",
      "billing_item_display_name": "Example usage",
      "unit": "token",
      "status": "charged",
      "quantity": "1000",
      "gross_credit": "1.000000000000",
      "discount_credit": "0.100000000000",
      "net_credit": "0.900000000000",
      "source_record_ids": [
        "rated_record_example"
      ],
      "source_record_count": 1
    }
  ],
  "total_credit": "0.900000000000",
  "granularity": "period",
  "timezone": "Asia/Shanghai",
  "from": "2026-09-01T00:00:00+08:00",
  "to": "2026-10-01T00:00:00+08:00"
}
```

:::::
:::::{tab-item} 字段说明

| 字段 | 类型 | 说明 |
| --- | --- | --- |
| `items` | array of object | 聚合结果。 |
| `items[].bucket_start` | string | 时间桶起点，RFC 3339 时间。 |
| `items[].bucket_end` | string | 时间桶终点，不包含该时刻。 |
| `items[].bucket_start_unix` | integer | 时间桶起点，Unix 秒。 |
| `items[].bucket_end_unix` | integer | 时间桶终点，Unix 秒。 |
| `items[].period` | string | 用量账期，格式为 `YYYY-MM`。 |
| `items[].meter_code` | string | 计量项代码。 |
| `items[].billing_item_code` | string | 计费项代码。 |
| `items[].billing_item_display_name` | string | 计费项显示名称。 |
| `items[].unit` | string | 用量计量单位。 |
| `items[].workspace_id` | string | 工作区 ID；未关联工作区时可能省略。 |
| `items[].status` | string | 参与聚合的用量记录状态。 |
| `items[].quantity` | string | 用量，使用对应计费项的计量单位。 |
| `items[].gross_credit` | string | 折扣前费用，单位为 Credit。 |
| `items[].discount_credit` | string | 折扣抵扣，单位为 Credit。 |
| `items[].net_credit` | string | 折扣后费用，单位为 Credit。 |
| `items[].source_record_ids` | array of string | 参与聚合的计费用量记录 ID。 |
| `items[].source_record_count` | integer | 参与聚合的记录数。 |
| `total_credit` | string | 返回各组折扣后费用之和，单位为 Credit。 |
| `granularity` | string | 实际使用的时间粒度。 |
| `timezone` | string | 实际使用的 IANA 时区。 |
| `from` | string | 实际查询起点，包含该时刻。 |
| `to` | string | 实际查询终点，不包含该时刻。 |

字段路径中的 `[]` 表示数组中的每一项。例如，`items[].bucket_start` 表示数组中每一项的对应字段。

:::::
::::::
:::::::

## 错误响应

时间粒度不受支持时返回 HTTP `400`，请修改查询参数。

:::::::{div} mo-api-tabs mo-api-response-tabs
::::::{tab-set}
:::::{tab-item} 响应示例

```json
{
  "code": "invalid_request",
  "message": "invalid request",
  "error": "invalid request"
}
```

:::::
:::::{tab-item} 字段说明

| 字段 | 类型 | 说明 |
| --- | --- | --- |
| `code` | string | 错误代码。 |
| `message` | string | 错误说明。 |
| `error` | string | 兼容错误说明，与 message 内容相同。 |

:::::
::::::
:::::::
